#!/usr/bin/perl -w

#$Header: /home2/cvsroot/LogTrend/Agent/AlarmDescriptionSet.pm,v 1.7 2001/10/05 11:55:08 slhullier Exp $
##******************************************************************************
## Class AlarmDescriptionSet
##  Description  : class to stock alarms descriptions
##  Project      : LogTrend 1.0.0.0 - Atrid Systemes
##  Author       : Sylvain Lhullier s.lhullier@atrid.fr
##  Author       : David Mascle d.mascle@atrid.fr
##******************************************************************************
#$Log: AlarmDescriptionSet.pm,v $
#Revision 1.7  2001/10/05 11:55:08  slhullier
#in the other case -> otherwise
#
#Revision 1.6  2001/06/07 14:08:54  slhullier
#
#Passage de  unshift @INC,'..';  aux packages Logtrend::....
#
#Revision 1.5  2001/02/22 17:02:23  slhullier
#
#Gestion des systemes de fichiers par LinuxAgent.
#Premiers tests concluants, reste a ajouter des alarmes et a faire
#des tests en situation reelle.
#
#Revision 1.4  2001/02/20 17:01:27  slhullier
#
#Mise en commentaire (+tab etc)
#
#Revision 1.3  2001/02/20 15:50:20  slhullier
#
#Apres modification du nom de certaines classes
#
#Revision 1.2  2001/02/20 10:21:55  slhullier
#
#Passage de la fonction de parsage de config XML dans Agent.pm
#Creation des tags Generic et Specific
#Fichiers agentdescription.xml plus lisibles (avec \n)
#Supression de methodes pas appellee du fichier Agent.pm
#
#Revision 1.1.1.1  2001/02/06 09:48:27  fdubuy
#
#First CVS version : all work done by D.Mascle
#
#

package LogTrend::Agent::AlarmDescriptionSet;

use LogTrend::Agent::AlarmDescription;

##******************************************************************************
## Constructor  public
##  Description  : creat a new AlarmDescriptionSet
##******************************************************************************
sub new
{
   my ($classname) = @_;
   my $self = {};
   bless($self, $classname);
   return $self;
}

##******************************************************************************
## Method AlarmDescriptionExists  private
##  Description  : test if an alarm description exists
##  Parameters   : as alarm description number
##  Return value : 1 if the alarm description exists and 0 otherwise
##******************************************************************************
sub AlarmDescriptionExists
{
   my ($self, $number) = @_;
   my $result = 0;

   if (defined @{$self->{ALARMDESCRIPTIONLIST}})
   {
      my $nbalarms = @{$self->{ALARMDESCRIPTIONLIST}};
      my $ind = 0;

      while (!$result && ($ind < $nbalarms))
      {
         if ($self->{ALARMDESCRIPTIONLIST}[$ind]->GetNumber() == $number)
         {
            $result = 1;
         }
         $ind++;
      }
   }

   return $result;
}

##******************************************************************************
## Method ConvertToXml  public
##  Description  : formats the alarms descriptions list in xml
##  Parameters   : none
##  Return value : an xml string representation of the alarms descriptions list
##******************************************************************************
sub ConvertToXml
{
   my $self = shift;
   my $result = "";

   $result = $result."<AlarmDescriptionSet>\n";

   my $alarmdescription = undef;

   foreach $alarmdescription (@{$self->{ALARMDESCRIPTIONLIST}})
   {
      $result = $result.${alarmdescription}->ConvertToXml();
   }

   $result = $result."</AlarmDescriptionSet>\n";

   return $result;
}

##******************************************************************************
## Method AddAlarmDescription  public
##  Description  : adds an alarm description to the alarms descriptions list
##  Parameters   : an alarm number, an alarm level,
##                 an information message about the alarm, an internal-info
##  Return value : 1 if successfull and 0 otherwise
##******************************************************************************
sub AddAlarmDescription
{
   my ($self, $number, $level, $message, $internal) = @_;
   my $result = 0;

   if (!$self->AlarmDescriptionExists($number))
   {
      push( @{$self->{ALARMDESCRIPTIONLIST}},
            LogTrend::Agent::AlarmDescription->new($number, $level, $message, $internal) );
      $result = 1;
   }

   return $result;
}

##******************************************************************************
1;
